/* Copyright (c): 2006, Mark Grebe */

/* Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */
#import <Cocoa/Cocoa.h>
#import "PasteWindow.h"

/* Subclass of NSWindow to allow for drag and drop and other specific functions  */
@interface TrsWindow : PasteWindow
+ (void)createApplicationWindow:(int)width:(int)height;
+ (NSPoint)applicationWindowOriginSave;
+ (void)applicationWindowOriginSetPrefs;
+ (void)applicationWindowOriginSet:(NSPoint)origin;
- (void)resizeApplicationWindow:(int)width:(int)height;
#if 0 // TBD MDG
- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;
#endif
- (void)display;
- (void)superDisplay;
+ (NSWindow *)ourWindow;
@end

/* Delegate for our NSWindow to send SDLQuit() on close */
@interface TrsWindowDelegate : NSObject
{}
- (BOOL)windowShouldClose:(id)sender;
@end

/* Subclass of NSQuickDrawView for the window's subview */
@interface TrsWindowView : NSQuickDrawView
{}
@end

